Subject: bug#21587: closed (Re: bug#21587: Mac: Segfault when unloading shared object linked to libguile)

From: [email-masked] (GNU bug Tracking System)
Date: Tue, 28 Feb 2017 14:30:02 +0000

Your bug report

#21587: Mac: Segfault when unloading shared object linked to libguile

which was filed against the guile package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
21587: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=21587
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#21587: Mac: Segfault when unloading shared object linked to libguile
From: Andy Wingo <[email-masked]>
To: Wilhelm Schuster <[email-masked]>
Cc: [email-masked]
Date: Tue, 28 Feb 2017 15:29:31 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Closing as not-a-bug given discussion below.  Please reply if you have
additional comments/etc.  Thanks.

Andy

On Fri 24 Jun 2016 14:32, Andy Wingo <[email-masked]> writes:

> On Tue 29 Sep 2015 20:21, Wilhelm Schuster <[email-masked]> writes:
>
>> The basic run down: When I try to unload (using dlclose() ) a shared
>> object that is linked to libguile after calling scm_init_guile() OR
>> scm_with_guile(), a Segfault is triggered.
>
> Hummmmmmmmmmmm!  Well, so this is quite tricky.  Loading Guile loads
> Guile which might start threads (some helper threads behind the scenes
> for finalization (see section on scm_set_automatic_finalization_enabled
> in tha manual), perhaps a thread to listen for signals, and then the
> garbage collector that we use (libgc) might start parallel marking
> threads (though you can control that parameter too).
>
> Guile doesn't really provide an interface to allow it to shut down
> cleanly and I don't know if it can.  (I guess it could.)  However it
> would take quite some amount of work and I don't see us doing it any
> time soon.  In any case simply trying to dlclose() is never likely to
> work, as you aren't synchronizing with Guile itself.
>
> Sorry for the bad news!
>
> Andy

Subject: Mac: Segfault when unloading shared object linked to libguile
From: Wilhelm Schuster <[email-masked]>
To: [email-masked]
Date: Tue, 29 Sep 2015 20:21:29 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi,

I have a rather weird issue with guile on OSX Yosemite (10.10.5). The 
problem originally stems from weechat [1] which provides guile scripting 
through a dynamically loaded "plugin" (shared object). However, I was 
able to extract the problem into a smaller test program.

The basic run down: When I try to unload (using dlclose() ) a shared 
object that is linked to libguile after calling scm_init_guile() OR 
scm_with_guile(), a Segfault is triggered.

Here is my test case:

$ cat test.c
#include <stdio.h>
#include <dlfcn.h>

typedef int (*guile_func)(void);

int main (void) {
     void *guile = NULL;
     guile_func init_func = NULL;

     printf("Loading Guile... ");
     guile = dlopen("guile.so", RTLD_GLOBAL | RTLD_NOW);
     if (!guile) printf("Error!\n");
     else printf("Done!\n");

     printf("Trying to load \"init_guile\" ");
     init_func = dlsym(guile, "init_guile");
     if (!init_func) printf("Error!\n");
     else {
         printf("Done!\n");
         printf("Trying to run \"init_guile\"\n");
         init_func();
     }

     printf("Unloading Guile... ");
     fflush(stdout);
     dlclose(guile);
     printf("Done!\n");
}
$ cat guile.c
#include <libguile.h>

extern void init_guile(void);

void init_guile(void) {
     scm_init_guile();
}

When I compile and run the program I get the following output:

$ clang -g -shared -o guile.so guile.c $(pkg-config --cflags --libs 
guile-2.0)
$ clang -g test.c -o test
$ ./test
Loading Guile... Done!
Trying to load "init_guile" Done!
Trying to run "init_guile"
Unloading Guile... [1]    41550 segmentation fault  ./test

The expected output:

Loading Guile... Done!
Trying to load "init_guile" Done!
Trying to run "init_guile"
Unloading Guile... Done!

Here's an excerpt from the output when enabling dyld (dynamic linker) 
debugging information:

$ DYLD_PRINT_APIS=1 ./test
[...]
   dlopen(guile.so) ==> 0x7fbcc8e00000
Loading Guile... Done!
dlsym(0x7fbcc8e00000, init_guile)
Trying to load "init_guile" Done!
Trying to run "init_guile"
[...]
Unloading Guile... dlclose(0x7fbcc8e00000)
dlclose(), found unused image 0x7fbcc8e00000 guile.so
dlclose(), found unused image 0x7fbcc8c00170 libguile-2.0.22.dylib
dlclose(), found unused image 0x7fbcc8d04930 libgc.1.dylib
dlclose(), found unused image 0x7fbcc8e00140 libffi.6.dylib
dlclose(), found unused image 0x7fbcc8f00000 libunistring.2.dylib
dlclose(), found unused image 0x7fbcc8f00130 libgmp.10.dylib
dlclose(), found unused image 0x7fbcc8e001d0 libltdl.7.dylib
dlclose(), deleting 0x7fbcc8e00000 guile.so
dlclose(), deleting 0x7fbcc8c00170 libguile-2.0.22.dylib
dlclose(), deleting 0x7fbcc8d04930 libgc.1.dylib
dlclose(), deleting 0x7fbcc8e00140 libffi.6.dylib
[1]    41585 segmentation fault  DYLD_PRINT_APIS=1 ./test

I have attached a lldb debugging session with backtrace.

Cheers, Wilhelm Schuster.